// FBWFCMDS.cpp : Defines the initialization routines for the DLL.
//
//
//SJJ Embedded Micro Solutions
//Copyright (c) 2007 SJJ Micro Solutions    All Rights Reserved
//
//EWFNET DLL
//
// Date: 4/25/07 - Comments generated
//			Provides a few examples of the FBWF API C++ command calls.



#include "stdafx.h"
#include "FBWFCMDS.h"
#include <stdio.h>
#include <windows.h>
#include "fbwfapi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//TODO: If this DLL is dynamically linked against the MFC DLLs,
//		any functions exported from this DLL which call into
//		MFC must have the AFX_MANAGE_STATE macro added at the
//		very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//


// CFBWFCMDSApp

BEGIN_MESSAGE_MAP(CFBWFCMDSApp, CWinApp)
END_MESSAGE_MAP()


// CFBWFCMDSApp construction

CFBWFCMDSApp::CFBWFCMDSApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CFBWFCMDSApp object

CFBWFCMDSApp theApp;


// CFBWFCMDSApp initialization

BOOL CFBWFCMDSApp::InitInstance()
{
	CWinApp::InitInstance();

	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
/*
FBWF Enable



*/
/////////////////////////////////////////////////////////////////////////////

LPCTSTR FBWFEnable ( void ) 
{
	LPCTSTR sResult;

	if(!FbwfEnableFilter())
	{
		sResult = "FBWF Enabled";
		return sResult;
	}
	else{
		sResult = "FBWF Enabled - Failed";
		return sResult;
	}
}
/////////////////////////////////////////////////////////////////////////////
/*
FBWF Disable



*/
/////////////////////////////////////////////////////////////////////////////
LPCTSTR FBWFDisable ( void ) {

	LPCTSTR sResult;
	
	if(!FbwfDisableFilter()){
		sResult = "FBWF Disabled";
		return sResult;
	}
	else{
		sResult = "FBWF Disabled- Failed";
		return sResult;
	}


}

/////////////////////////////////////////////////////////////////////////////
/*
FBWF Enable Compression



*/
/////////////////////////////////////////////////////////////////////////////


LPCTSTR FBWFEnableCompression(void) {

	LPCTSTR sResult;

			if(!FbwfEnableCompression( )){
				sResult = "FBWF Compression Enabled";
				return sResult;
			}
			else{
				sResult = "Enabled Compression - Error";
				return sResult;
			}


}

/////////////////////////////////////////////////////////////////////////////
/*
FBWF Disable Compression



*/
/////////////////////////////////////////////////////////////////////////////

LPCTSTR FBWFDisableCompression(void) {

	LPCTSTR sResult;

			if(!FbwfDisableCompression( )){
				sResult = "FBWF Compression Disabled";
				return sResult;
			}
			else{
				sResult = "Disable Compression - Error";
				return sResult;
			}


}

/////////////////////////////////////////////////////////////////////////////
/*
Enable FBWF Cache PreAllocation



*/
/////////////////////////////////////////////////////////////////////////////

LPCTSTR FBWFEnableCache(void) {

	LPCTSTR sResult;

			if(!FbwfEnableCachePreAllocation( )){
				sResult = "FBWF Cache PreAllocation enabled";
				return sResult;
			}
			else{
				sResult = "EnableCachePreAllocation Error";
				return sResult;
			}


}

/////////////////////////////////////////////////////////////////////////////
/*
Disable FBWF Cache PreAllocation



*/
/////////////////////////////////////////////////////////////////////////////

LPCTSTR FBWFDisableCache(void) {

	LPCTSTR sResult;

			if(!FbwfDisableCachePreAllocation( )){
				sResult = "FBWF Cache PreAllocation disabled.";
				return sResult;
			}
			else{
				sResult = "DisableCachePreAllocation Error";
				return sResult;
			}


}




/////////////////////////////////////////////////////////////////////////////
/*
FBWF Status



*/
/////////////////////////////////////////////////////////////////////////////
LPCTSTR FBWFStatus ( void ) {

	LPCTSTR sResult;
	ULONG IscsEnabled = 0;
	ULONG IsnsEnabled = 0;

		if(!FbwfIsFilterEnabled(&IscsEnabled, &IsnsEnabled )){
			if(IscsEnabled){

				if(IsnsEnabled){

						sResult = "11";
					}
					else{
						sResult = "10";
					}
			}
			else{
				if(IsnsEnabled){

						sResult = "01";
					}
					else{
						sResult = "00";
					}
			}

			return sResult;

		}
		else{
			sResult = "Error";
			return sResult;
		}


}

/////////////////////////////////////////////////////////////////////////////
/*
FBWF Cache Status



*/
/////////////////////////////////////////////////////////////////////////////
LPCTSTR FBWFCacheStatus ( void ) {

	LPCTSTR sResult;
	ULONG IscsEnabled = 0;
	ULONG IsnsEnabled = 0;

		if(!FbwfIsCachePreAllocationEnabled(&IscsEnabled, &IsnsEnabled )){
			if(IscsEnabled){

				if(IsnsEnabled){

						sResult = "11";
					}
					else{
						sResult = "10";
					}
			}
			else{
				if(IsnsEnabled){

						sResult = "01";
					}
					else{
						sResult = "00";
					}
			}

			return sResult;

		}
		else{
			sResult = "Error";
			return sResult;
		}


}


/////////////////////////////////////////////////////////////////////////////
/*
FBWF Compression Status



*/
/////////////////////////////////////////////////////////////////////////////
LPCTSTR FBWFCompressionStatus ( void ) {

	LPCTSTR sResult;
	ULONG IscsEnabled = 0;
	ULONG IsnsEnabled = 0;

		if(!FbwfIsCompressionEnabled(&IscsEnabled, &IsnsEnabled )){
			if(IscsEnabled){

				if(IsnsEnabled){

						sResult = "11";
					}
					else{
						sResult = "10";
					}
			}
			else{
				if(IsnsEnabled){

						sResult = "01";
					}
					else{
						sResult = "00";
					}
			}

			return sResult;

		}
		else{
			sResult = "Error";
			return sResult;
		}


}